;(--------------Constants and arrays Declarations-------------
(declare-const T_IP_OP (Int))
(declare-const T_IP_VirAddr (Int))
(declare-const T_IP_Value (Int))
(declare-const T_IP_InstPID (_ BitVec 1))
(declare-const T_IP_ValuePID (_ BitVec 1))
(declare-const T_IP_Done (_ BitVec 1))


(declare-const T_StoreBuffer_Busy (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_StoreBuffer_VirAddr (Array (_ BitVec 2) Int))
(declare-const T_StoreBuffer_Value (Array (_ BitVec 2) Int))
(declare-const T_StoreBuffer_PID (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_LoadBuffer_Busy (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_LoadBuffer_VirAddr (Array (_ BitVec 2) Int))
(declare-const T_LoadBuffer_Value (Array (_ BitVec 2) Int))
(declare-const T_LoadBuffer_PID (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_CacheL1_Busy (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_CacheL1_Dirty (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_CacheL1_PhyAddr (Array (_ BitVec 2) Int))
(declare-const T_CacheL1_VirAddr (Array (_ BitVec 2) Int))
(declare-const T_CacheL1_Value (Array (_ BitVec 2) Int))
(declare-const T_CacheL1_PID (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const L1D_TLB (Array Int Int))

(declare-const T_LFB_Busy (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_LFB_OP (Array (_ BitVec 2) Int))
(declare-const T_LFB_PhyAddr (Array (_ BitVec 2) Int))
(declare-const T_LFB_VirAddr (Array (_ BitVec 2) Int))
(declare-const T_LFB_Value (Array (_ BitVec 2) Int))
(declare-const T_LFB_PID (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_LFB_WakeupID (Array (_ BitVec 2) (_ BitVec 2)))

;(declare-const T_CacheL2_PhyAddr (Array Int Int))
;(declare-const T_CacheL2_VirAddr (Array Int Int))
(declare-const T_CacheL2_Value (Array Int Int))
;(declare-const T_CacheL2_PID (Array Int (_ BitVec 1)))

(declare-const Load Int)
(declare-const Store Int)
(declare-const TL2 Int)
;)


(assert
	(not
;--------------------------- Load Input --------------------------------------------------------------
; If the input from LSU is a load first a forwarding check is done, the order of check is Store buffer, L1D, LFB.
; If forwarding is failed the load is then put into Load buffer and Line fill buffer, the Line Fill buffer will eventually service the instruction
; If any of the buffer is full then the input will be stalled. 
		
		(let
			(
				(U_IP_Value	
				;--------- Checking Store Buffer ---------- Priority Order Bottom to Top ---- 3->0 ----
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv3 2)))) (select T_StoreBuffer_Value (_ bv3 2))	;most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv2 2)))) (select T_StoreBuffer_Value (_ bv2 2))	;second most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv1 2)))) (select T_StoreBuffer_Value (_ bv1 2))	;second oldest Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv0 2)))) (select T_StoreBuffer_Value (_ bv0 2))	;oldest Store buffer entry
					
				;--------- Store Buffer Miss ------ Cheaking L1d ---------- Fully Associative Cache ---- Order of checking doesnt matter -----
				
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv0 2)))) (select T_CacheL1_Value (_ bv0 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv1 2)))) (select T_CacheL1_Value (_ bv1 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv2 2)))) (select T_CacheL1_Value (_ bv2 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv3 2)))) (select T_CacheL1_Value (_ bv3 2))
				
				;--------- L1D Miss------ Cheaking LFB ---------- Priority Order Bottom to Top ---- 3->0 ----
				
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv3 2))) (= #b1 (select T_LFB_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv3 2)))) (select T_LFB_Value (_ bv3 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv2 2))) (= #b1 (select T_LFB_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv2 2)))) (select T_LFB_Value (_ bv2 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv1 2))) (= #b1 (select T_LFB_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv1 2)))) (select T_LFB_Value (_ bv1 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv0 2))) (= #b1 (select T_LFB_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv0 2)))) (select T_LFB_Value (_ bv0 2))

				;--------- Forwarding failed or it was not a load instruction ----- Dont Update the Value in Input ---------------------------------------------				
					
					T_IP_Value))))
					
					))))))))
				)
				
				
				(U_IP_ValuePID	
				;--------- Checking Store Buffer ---------- Priority Order Bottom to Top ---- 3->0 ----
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv3 2)))) (select T_StoreBuffer_PID (_ bv3 2))	;most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv2 2)))) (select T_StoreBuffer_PID (_ bv2 2))	;second most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv1 2)))) (select T_StoreBuffer_PID (_ bv1 2))	;second oldest Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv0 2)))) (select T_StoreBuffer_PID (_ bv0 2))	;oldest Store buffer entry
					
				;--------- Store Buffer Miss ------ Cheaking L1d ---------- Fully Associative Cache ---- Order of checking doesnt matter -----
				
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv0 2)))) (select T_CacheL1_PID (_ bv0 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv1 2)))) (select T_CacheL1_PID (_ bv1 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv2 2)))) (select T_CacheL1_PID (_ bv2 2))
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv3 2)))) (select T_CacheL1_PID (_ bv3 2))
				
				;--------- L1D Miss------ Cheaking LFB ---------- Priority Order Bottom to Top ---- 3->0 ----
				
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv3 2))) (= #b1 (select T_LFB_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv3 2)))) (select T_LFB_PID (_ bv3 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv2 2))) (= #b1 (select T_LFB_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv2 2)))) (select T_LFB_PID (_ bv2 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv1 2))) (= #b1 (select T_LFB_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv1 2)))) (select T_LFB_PID (_ bv1 2))
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv0 2))) (= #b1 (select T_LFB_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv0 2)))) (select T_LFB_PID (_ bv0 2))
				
				;--------- Forwarding failed or it was not a load instruction ----- Dont Update the PID in Input ---------------------------------------------				
					
					T_IP_ValuePID))))
					
					))))))))
				)
				
				(U_IP_InstPID (bvadd T_IP_InstPID (_ bv0 1)))	;instruction pid remains the same in next cycle
				
				(S_T_Fwded	
				;--------- Checking Store Buffer ---------- Priority Order Bottom to Top ---- 3->0 ----
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv3 2)))) (_ bv1 1)	;most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv2 2)))) (_ bv1 1)	;second most recent Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv1 2)))) (_ bv1 1)	;second oldest Store buffer entry
					(ite (and (= Load T_IP_OP) (= #b1 (select T_StoreBuffer_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_StoreBuffer_VirAddr (_ bv0 2)))) (_ bv1 1)	;oldest Store buffer entry
					
				;--------- Store Buffer Miss ------ Cheaking L1d ---------- Fully Associative Cache ---- Order of checking doesnt matter -----
				
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv0 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv1 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv2 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= #b1 (select T_CacheL1_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_CacheL1_VirAddr (_ bv3 2)))) (_ bv1 1)
				
				;--------- L1D Miss------ Cheaking LFB ---------- Priority Order Bottom to Top ---- 3->0 ----
				
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv3 2))) (= #b1 (select T_LFB_Busy (_ bv3 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv3 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv2 2))) (= #b1 (select T_LFB_Busy (_ bv2 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv2 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv1 2))) (= #b1 (select T_LFB_Busy (_ bv1 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv1 2)))) (_ bv1 1)
					(ite (and (= Load T_IP_OP) (= Store (select T_LFB_OP (_ bv0 2))) (= #b1 (select T_LFB_Busy (_ bv0 2))) (= T_IP_VirAddr (select T_LFB_VirAddr (_ bv0 2)))) (_ bv1 1)
				
				;--------- Forwarding failed or it was not a load instruction ----- The instruction is not done and needs to be put into buffer ---------------------------------------------				
					
					(_ bv0 1)))))))))))))
				)
			)
		(let
			(
				(Lbuffer (ite (and (= Load T_IP_OP) (= #b0 S_T_Fwded)) (_ bv1 1) (_ bv0 1)))	;If the instruction was load and value was not forwarded it will be kept in LFB and Load buffer untill it completes
				
				(loadbuffer_stall	;there needs to space in LFB and Load buffer or else the LSU input stalls 
					(ite
						(and
							(or
								(= #b0 (select T_LoadBuffer_Busy (_ bv0 2)))
								(= #b0 (select T_LoadBuffer_Busy (_ bv1 2)))
								(= #b0 (select T_LoadBuffer_Busy (_ bv2 2)))
								(= #b0 (select T_LoadBuffer_Busy (_ bv3 2)))
							)
							(or 
								(= #b0 (select T_LFB_Busy (_ bv0 2)))
								(= #b0 (select T_LFB_Busy (_ bv1 2)))
								(= #b0 (select T_LFB_Busy (_ bv2 2)))
								(= #b0 (select T_LFB_Busy (_ bv3 2)))
							)
						)(_ bv1 1) (_ bv0 1)
					)
				)
			)
		(let
			(
				(U_LoadBuffer_Busy	;Input was not stalled and is inserted into Load buffer: Filling order 0 -> 3
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv0 2)))) (store T_LoadBuffer_Busy (_ bv0 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv1 2)))) (store T_LoadBuffer_Busy (_ bv1 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv2 2)))) (store T_LoadBuffer_Busy (_ bv2 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv3 2)))) (store T_LoadBuffer_Busy (_ bv3 2) (_ bv1 1))
					T_LoadBuffer_Busy))))
				)
				
				(U_LoadBuffer_VirAddr	
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv0 2)))) (store T_LoadBuffer_VirAddr (_ bv0 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv1 2)))) (store T_LoadBuffer_VirAddr (_ bv1 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv2 2)))) (store T_LoadBuffer_VirAddr (_ bv2 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv3 2)))) (store T_LoadBuffer_VirAddr (_ bv3 2) T_IP_VirAddr)
					T_LoadBuffer_VirAddr))))
				)
				
				(U_LoadBuffer_Value	
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv0 2)))) (store T_LoadBuffer_Value (_ bv0 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv1 2)))) (store T_LoadBuffer_Value (_ bv1 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv2 2)))) (store T_LoadBuffer_Value (_ bv2 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv3 2)))) (store T_LoadBuffer_Value (_ bv3 2) 0)
					T_LoadBuffer_Value))))
				)
				
				(U_LoadBuffer_PID	
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv0 2)))) (store T_LoadBuffer_PID (_ bv0 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv1 2)))) (store T_LoadBuffer_PID (_ bv1 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv2 2)))) (store T_LoadBuffer_PID (_ bv2 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LoadBuffer_Busy (_ bv3 2)))) (store T_LoadBuffer_PID (_ bv3 2) T_IP_InstPID)
					T_LoadBuffer_PID))))
				)
				
				
				
				(U_LFB_Busy	;Input was not stalled and is inserted into LFB: Filling order 0 -> 3
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_Busy (_ bv0 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_Busy (_ bv1 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_Busy (_ bv2 2) (_ bv1 1))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_Busy (_ bv3 2) (_ bv1 1))
					T_LFB_Busy))))
				)
				
				(U_LFB_OP
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_OP (_ bv0 2) Load)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_OP (_ bv1 2) Load)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_OP (_ bv2 2) Load)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_OP (_ bv3 2) Load)
					T_LFB_OP))))
				)
				
				(U_LFB_PhyAddr
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_PhyAddr (_ bv0 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_PhyAddr (_ bv1 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_PhyAddr (_ bv2 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_PhyAddr (_ bv3 2) 0)
					T_LFB_PhyAddr))))
				)
				
				(U_LFB_VirAddr
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_VirAddr (_ bv0 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_VirAddr (_ bv1 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_VirAddr (_ bv2 2) T_IP_VirAddr)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_VirAddr (_ bv3 2) T_IP_VirAddr)
					T_LFB_VirAddr))))
				)
				
				(U_LFB_Value
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_Value (_ bv0 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_Value (_ bv1 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_Value (_ bv2 2) 0)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_Value (_ bv3 2) 0)
					T_LFB_Value))))
				)
				
				(U_LFB_PID
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_PID (_ bv0 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_PID (_ bv1 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_PID (_ bv2 2) T_IP_InstPID)
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_PID (_ bv3 2) T_IP_InstPID)
					T_LFB_PID))))
				)
				
				(U_LFB_WakeupID	;Load Buffer Corresponding to the LFB entry. 
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv0 2)))) (store T_LFB_WakeupID (_ bv0 2) (_ bv0 2))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv1 2)))) (store T_LFB_WakeupID (_ bv1 2) (_ bv1 2))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv2 2)))) (store T_LFB_WakeupID (_ bv2 2) (_ bv2 2))
					(ite (and (= #b1 Lbuffer) (= #b0 loadbuffer_stall) (= #b0 (select T_LFB_Busy (_ bv3 2)))) (store T_LFB_WakeupID (_ bv3 2) (_ bv3 2))
					T_LFB_WakeupID))))
				)
				
				(U_IP_Done (ite (and (= Load T_IP_OP) (or (= #b1 S_T_Fwded) (= #b0 loadbuffer_stall))) (_ bv1 1) T_IP_Done))	 ;LSU IP is done for now if it was load and got value fwded or got insrted into the buffers 
			)
			
			
;---------------------------Input is Store: Put it into the Store Buffer: If full, Stall: Filling Order 0->3  --------------------------------------------------------
;If the Input is Store its inserted into the store buffer directly, reason being that 
;if it goes into the L1D direcctly then Store will update the values out of order because same address instruction might be in the Store buffer
;Input will stall if the store buffer is full 
;THe store buffer entires are retired sequentially.
;First L1D is check for a hit, if its a hit the cache line is updated. If its a miss and a line is avilable then value is inserted in that line.
;If its a miss and L1D is full then a LFB line is allocated. 
;If L1D is full, miss and LFB is full the store buffer stalls. 
	
		
		(let	;Checking Buffer Entry 0 if its empty then fill it up and mark inst as done, if not then check the next entry i.e. entry 1
			(	
				(U_StoreBuffer_Busy (ite (and (= Store T_IP_OP) (= #b0 T_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv0 2)))) (store T_StoreBuffer_Busy (_ bv0 2) (_ bv1 1)) T_StoreBuffer_Busy))
				(U_StoreBuffer_VirAddr (ite (and (= Store T_IP_OP) (= #b0 T_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv0 2)))) (store T_StoreBuffer_VirAddr (_ bv0 2) T_IP_VirAddr) T_StoreBuffer_VirAddr))
				(U_StoreBuffer_Value (ite (and (= Store T_IP_OP) (= #b0 T_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv0 2)))) (store T_StoreBuffer_Value (_ bv0 2) T_IP_Value) T_StoreBuffer_Value))
				(U_StoreBuffer_PID (ite (and (= Store T_IP_OP) (= #b0 T_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv0 2)))) (store T_StoreBuffer_PID (_ bv0 2) T_IP_InstPID) T_StoreBuffer_PID))
				
				(U_IP_Done (ite (and (= Store T_IP_OP) (= #b0 T_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv0 2)))) (_ bv1 1) T_IP_Done))
			)
		(let	;Checking Buffer Entry 1 if its empty then fill it up and mark inst as done, if not then check the next entry i.e. entry 2
			(	
				(U_StoreBuffer_Busy (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv1 2)))) (store T_StoreBuffer_Busy (_ bv1 2) (_ bv1 1)) T_StoreBuffer_Busy))
				(U_StoreBuffer_VirAddr (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv1 2)))) (store T_StoreBuffer_VirAddr (_ bv1 2) T_IP_VirAddr) T_StoreBuffer_VirAddr))
				(U_StoreBuffer_Value (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv1 2)))) (store T_StoreBuffer_Value (_ bv1 2) T_IP_Value) T_StoreBuffer_Value))
				(U_StoreBuffer_PID (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv1 2)))) (store T_StoreBuffer_PID (_ bv1 2) T_IP_InstPID) T_StoreBuffer_PID))
				
				(U_IP_Done (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv1 2)))) (_ bv1 1) U_IP_Done))
			)
		(let	;Checking Buffer Entry 2 if its empty then fill it up and mark inst as done, if not then check the next entry i.e. entry 3
			(	
				(U_StoreBuffer_Busy (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (store T_StoreBuffer_Busy (_ bv2 2) (_ bv1 1)) T_StoreBuffer_Busy))
				(U_StoreBuffer_VirAddr (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (store T_StoreBuffer_VirAddr (_ bv2 2) T_IP_VirAddr) T_StoreBuffer_VirAddr))
				(U_StoreBuffer_Value (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (store T_StoreBuffer_Value (_ bv2 2) T_IP_Value) T_StoreBuffer_Value))
				(U_StoreBuffer_PID (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (store T_StoreBuffer_PID (_ bv2 2) T_IP_InstPID) T_StoreBuffer_PID))
				
				(U_IP_Done (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (_ bv1 1) U_IP_Done))
			)
		(let	;Checking Buffer Entry 3 if its empty then fill it up and mark inst as done, if not then store gets stalled
			(	
				(U_StoreBuffer_Busy (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv3 2)))) (store T_StoreBuffer_Busy (_ bv3 2) (_ bv1 1)) T_StoreBuffer_Busy))
				(U_StoreBuffer_VirAddr (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv3 2)))) (store T_StoreBuffer_VirAddr (_ bv3 2) T_IP_VirAddr) T_StoreBuffer_VirAddr))
				(U_StoreBuffer_Value (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv3 2)))) (store T_StoreBuffer_Value (_ bv3 2) T_IP_Value) T_StoreBuffer_Value))
				(U_StoreBuffer_PID (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv3 2)))) (store T_StoreBuffer_PID (_ bv3 2) T_IP_InstPID) T_StoreBuffer_PID))
				
				(U_IP_Done (ite (and (= Store T_IP_OP) (= #b0 U_IP_Done) (= #b0 (select T_StoreBuffer_Busy (_ bv2 2)))) (_ bv1 1) U_IP_Done))
			)

;--------------------------- Store Buffer to L1D, Check LFB for space If L1D is Full (L1D miss and no space), SB retire Order 0->3  --------------------------------------------------------	
		(let
			(
				(SB_Retire_index 	;fill sequence is 0 to 3, retirement sequence is 3 to 0 first in first out logic to maintain inorder
					(ite (= #b1 (select U_StoreBuffer_Busy (_ bv3 2))) (_ bv3 2)
					(ite (= #b1 (select U_StoreBuffer_Busy (_ bv2 2))) (_ bv2 2)
					(ite (= #b1 (select U_StoreBuffer_Busy (_ bv1 2))) (_ bv1 2)
					(ite (= #b1 (select U_StoreBuffer_Busy (_ bv0 2))) (_ bv0 2)
					(_ bv0 2)))))	;There are no entiries in SB to retire
				)
				
				(SB_Wanna_Retire 	; 1 if there is any entry to retire in SB, 0 if not
					(ite 
						(or
							(= #b1 (select U_StoreBuffer_Busy (_ bv0 2)))
							(= #b1 (select U_StoreBuffer_Busy (_ bv1 2)))
							(= #b1 (select U_StoreBuffer_Busy (_ bv2 2)))
							(= #b1 (select U_StoreBuffer_Busy (_ bv3 2)))
						)
						(_ bv1 1) (_ bv0 1)
					)
				)
			)
		(let
			(
				(SB_L1D_update
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv0 2))) (= (select T_CacheL1_VirAddr (_ bv0 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv1 1) ;Line 0 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv1 2))) (= (select T_CacheL1_VirAddr (_ bv1 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv1 1) ;Line 1 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv2 2))) (= (select T_CacheL1_VirAddr (_ bv2 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv1 1) ;Line 2 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv3 2))) (= (select T_CacheL1_VirAddr (_ bv3 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv1 1) ;Line 3 is a cache hit
					(ite (= #b0 (select T_CacheL1_Busy (_ bv0 2))) (_ bv1 1)	;Line 0 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv1 2))) (_ bv1 1)	;Line 1 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv2 2))) (_ bv1 1)	;Line 2 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv3 2))) (_ bv1 1)	;Line 3 is a available
					(_ bv0 1)))))))))	
				)
				
				(L1D_Avi_Index
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv0 2))) (= (select T_CacheL1_VirAddr (_ bv0 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv0 2) ;Line 0 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv1 2))) (= (select T_CacheL1_VirAddr (_ bv1 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv1 2) ;Line 1 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv2 2))) (= (select T_CacheL1_VirAddr (_ bv2 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv2 2) ;Line 2 is a cache hit
					(ite (and (= #b1 (select T_CacheL1_Busy (_ bv3 2))) (= (select T_CacheL1_VirAddr (_ bv3 2)) (select U_StoreBuffer_VirAddr SB_Retire_index))) (_ bv3 2) ;Line 3 is a cache hit
					(ite (= #b0 (select T_CacheL1_Busy (_ bv0 2))) (_ bv0 2)	;Line 0 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv1 2))) (_ bv1 2)	;Line 1 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv2 2))) (_ bv2 2)	;Line 2 is a available
					(ite (= #b0 (select T_CacheL1_Busy (_ bv3 2))) (_ bv3 2)	;Line 3 is a available
					(_ bv0 2)))))))))	
				)
			)
		(let
			(	;If Store Buffer retires any entry the L1D is then updated if there was a hit or available space for it. else left as is
				(U_CacheL1_Busy	(ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_Busy L1D_Avi_Index (_ bv1 1)) T_CacheL1_Busy))
				(U_CacheL1_Dirty (ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_Dirty L1D_Avi_Index (_ bv1 1)) T_CacheL1_Dirty))
				(U_CacheL1_PhyAddr (ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_PhyAddr L1D_Avi_Index (select L1D_TLB (select U_StoreBuffer_VirAddr SB_Retire_index))) T_CacheL1_PhyAddr))
				(U_CacheL1_VirAddr (ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_VirAddr L1D_Avi_Index (select U_StoreBuffer_VirAddr SB_Retire_index)) T_CacheL1_VirAddr))
				(U_CacheL1_Value (ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_Value L1D_Avi_Index (select U_StoreBuffer_Value SB_Retire_index)) T_CacheL1_Value))
				(U_CacheL1_PID (ite (and (= #b1 SB_L1D_update) (= #b1 SB_Wanna_Retire)) (store T_CacheL1_PID L1D_Avi_Index (select U_StoreBuffer_PID SB_Retire_index)) T_CacheL1_PID))
			)
		(let
			(
				(LFB_Full
					(ite
						(and 
							(= #b1 (select U_LFB_Busy (_ bv0 2)))
							(= #b1 (select U_LFB_Busy (_ bv1 2)))
							(= #b1 (select U_LFB_Busy (_ bv2 2)))
							(= #b1 (select U_LFB_Busy (_ bv3 2)))
						)
					(_ bv1 1) (_ bv0 1))
				)
				(LFB_Avi_Index
					(ite (= #b0 (select U_LFB_Busy (_ bv0 2))) (_ bv0 2)
					(ite (= #b0 (select U_LFB_Busy (_ bv1 2))) (_ bv1 2)
					(ite (= #b0 (select U_LFB_Busy (_ bv2 2))) (_ bv2 2)
					(ite (= #b0 (select U_LFB_Busy (_ bv3 2))) (_ bv3 2)
					(_ bv0 2)))))
				)
			)
;--------------------------- Store Buffer to LFB, Stall If LFB is Full (no space), SB retire Order 0->3  if l1d was miss and full it goes to LFB--------------------------------------------------------	
		(let
			(
				(U_LFB_Busy (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_Busy LFB_Avi_Index (_ bv1 1)) U_LFB_Busy))
				(U_LFB_OP (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_OP LFB_Avi_Index Store) U_LFB_OP))
				(U_LFB_PhyAddr (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_PhyAddr LFB_Avi_Index (select L1D_TLB (select U_StoreBuffer_VirAddr SB_Retire_index))) U_LFB_PhyAddr))
				(U_LFB_VirAddr (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_VirAddr LFB_Avi_Index (select U_StoreBuffer_VirAddr SB_Retire_index)) U_LFB_VirAddr))
				(U_LFB_Value (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_Value LFB_Avi_Index (select U_StoreBuffer_Value SB_Retire_index)) U_LFB_Value))
				(U_LFB_PID (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_PID LFB_Avi_Index (select U_StoreBuffer_PID SB_Retire_index)) U_LFB_PID))
				(U_LFB_WakeupID (ite (and (= #b1 SB_Wanna_Retire) (= #b0 SB_L1D_update) (= #b0 LFB_Full)) (store U_LFB_WakeupID LFB_Avi_Index SB_Retire_index) U_LFB_WakeupID))

;--------------------------- Store Buffer Retiring enrty clearing, If the entry sucessfully retires to L1d or LFB then clear the entry ------------------------
	
				(U_StoreBuffer_Busy (ite (and (= #b1 SB_Wanna_Retire) (or (= #b1 SB_L1D_update) (and (= #b0 SB_L1D_update) (= #b0 LFB_Full)))) (store U_StoreBuffer_Busy SB_Retire_index (_ bv0 1)) U_StoreBuffer_Busy))
				(U_StoreBuffer_VirAddr (ite (and (= #b1 SB_Wanna_Retire) (or (= #b1 SB_L1D_update) (and (= #b0 SB_L1D_update) (= #b0 LFB_Full)))) (store U_StoreBuffer_VirAddr SB_Retire_index 0) U_StoreBuffer_VirAddr))
				(U_StoreBuffer_Value (ite (and (= #b1 SB_Wanna_Retire) (or (= #b1 SB_L1D_update) (and (= #b0 SB_L1D_update) (= #b0 LFB_Full)))) (store U_StoreBuffer_Value SB_Retire_index 0) U_StoreBuffer_Value))
				(U_StoreBuffer_PID (ite (and (= #b1 SB_Wanna_Retire) (or (= #b1 SB_L1D_update) (and (= #b0 SB_L1D_update) (= #b0 LFB_Full)))) (store U_StoreBuffer_PID SB_Retire_index (_ bv0 1)) U_StoreBuffer_PID))
			)

;--------------------------- LFB retirment, LFB filles up 0 to 3 thus retirement sequence is 3 to 0 to maintain inorder--------------------------
		(let
			(
				(LFB_Retire_index 	
					(ite (= #b1 (select U_LFB_Busy (_ bv3 2))) (_ bv3 2)
					(ite (= #b1 (select U_LFB_Busy (_ bv2 2))) (_ bv2 2)
					(ite (= #b1 (select U_LFB_Busy (_ bv1 2))) (_ bv1 2)
					(ite (= #b1 (select U_LFB_Busy (_ bv0 2))) (_ bv0 2)
					(_ bv0 2)))))	;There are no entiries in LFB to retire
				)
				(LFB_Wanna_Retire 	; 1 if there is any entry to retire in LFBB, 0 if not
					(ite 
						(or
							(= #b1 (select U_LFB_Busy (_ bv0 2)))
							(= #b1 (select U_LFB_Busy (_ bv1 2)))
							(= #b1 (select U_LFB_Busy (_ bv2 2)))
							(= #b1 (select U_LFB_Busy (_ bv3 2)))
						)
						(_ bv1 1) (_ bv0 1)
					)
				)
			)

;--------------------------- LFB retirment, if its TL2 update the L2, if its store update the L2 and L1D, If its load, update the load buffer and L1D, If L1D is full, evict one entry to replace
		(let
			(
				(LFB_Op (select U_LFB_OP LFB_Retire_index))
				(LFB_PhyAddr (select U_LFB_PhyAddr LFB_Retire_index))
				(LFB_VirAddr (select U_LFB_VirAddr LFB_Retire_index))
				(LFB_Value (select U_LFB_Value LFB_Retire_index))
				(LFB_wakeupid (select U_LFB_WakeupID LFB_Retire_index))
				(LFB_PID (select U_LFB_PID LFB_Retire_index))
			)
		(let
			(
				(U_CacheL2_Value 
					(ite (and (= LFB_Op TL2) (= #b1 LFB_Wanna_Retire)) (store T_CacheL2_Value LFB_PhyAddr LFB_Value) ;if its TL2 then update the L2
					(ite (and (= LFB_Op Store) (= #b1 LFB_Wanna_Retire)) (store T_CacheL2_Value LFB_PhyAddr LFB_Value) ;if its Store then update the L2
					T_CacheL2_Value))
				)
				
				(U_LoadBuffer_Value (ite (and (= LFB_Op Load) (= #b1 LFB_Wanna_Retire)) (store U_LoadBuffer_Value LFB_wakeupid LFB_Value) U_LoadBuffer_Value)) ;if its load update the load buffer
			
				(Cache_full
					(ite 
						(and
							(= #b1 (select U_CacheL1_Busy (_ bv0 2)))
							(= #b1 (select U_CacheL1_Busy (_ bv1 2)))
							(= #b1 (select U_CacheL1_Busy (_ bv2 2)))
							(= #b1 (select U_CacheL1_Busy (_ bv3 2)))
						)
						(_ bv1 1) (_ bv0 1)
					)
				)
				(Cache_hit
					(ite
						(or
							(and (= #b1 (select U_CacheL1_Busy (_ bv0 2))) (= (select U_CacheL1_VirAddr (_ bv0 2)) LFB_VirAddr))
							(and (= #b1 (select U_CacheL1_Busy (_ bv1 2))) (= (select U_CacheL1_VirAddr (_ bv1 2)) LFB_VirAddr))
							(and (= #b1 (select U_CacheL1_Busy (_ bv2 2))) (= (select U_CacheL1_VirAddr (_ bv2 2)) LFB_VirAddr))
							(and (= #b1 (select U_CacheL1_Busy (_ bv3 2))) (= (select U_CacheL1_VirAddr (_ bv3 2)) LFB_VirAddr))
						)
						(_ bv1 1) (_ bv0 1)
					)
				)
				(Cache_hit_location
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv0 2))) (= (select U_CacheL1_VirAddr (_ bv0 2)) LFB_VirAddr)) (_ bv0 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv1 2))) (= (select U_CacheL1_VirAddr (_ bv1 2)) LFB_VirAddr)) (_ bv1 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv2 2))) (= (select U_CacheL1_VirAddr (_ bv2 2)) LFB_VirAddr)) (_ bv2 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv3 2))) (= (select U_CacheL1_VirAddr (_ bv3 2)) LFB_VirAddr)) (_ bv3 2)
					(_ bv0 2)))))
				)
				(Cache_avi_entry
					(ite (= #b0 (select U_CacheL1_Busy (_ bv0 2))) (_ bv0 2)
					(ite (= #b0 (select U_CacheL1_Busy (_ bv1 2))) (_ bv1 2)
					(ite (= #b0 (select U_CacheL1_Busy (_ bv2 2))) (_ bv2 2)
					(ite (= #b0 (select U_CacheL1_Busy (_ bv3 2))) (_ bv3 2)
					(_ bv0 2)))))
				)
				(cache_evict_entry	;if dirty evict if non are dirty evict 0
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv0 2))) (= #b1 (select U_CacheL1_Dirty (_ bv0 2)))) (_ bv0 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv1 2))) (= #b1 (select U_CacheL1_Dirty (_ bv1 2)))) (_ bv1 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv2 2))) (= #b1 (select U_CacheL1_Dirty (_ bv2 2)))) (_ bv2 2)
					(ite (and (= #b1 (select U_CacheL1_Busy (_ bv3 2))) (= #b1 (select U_CacheL1_Dirty (_ bv3 2)))) (_ bv3 2)
					(_ bv0 2)))))
				)	
			)
		(let
			(
				(U_CacheL1_Value (ite (and (= #b1 Cache_hit) (= #b1 LFB_Wanna_Retire) (or (= Load LFB_Op) (= Store LFB_Op))) (store U_CacheL1_Value Cache_hit_location LFB_Value) U_CacheL1_Value))	;is its a hit update the L1d value
				
			)
		(let
			(
				(U_CacheL1_Busy 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_Busy Cache_avi_entry (_ bv1 1)) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_Busy cache_evict_entry (_ bv1 1))	;if not hit and full update to evicting entry
					U_CacheL1_Busy))
				)
				(U_CacheL1_Dirty 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_Dirty Cache_avi_entry (_ bv0 1)) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_Dirty cache_evict_entry (_ bv0 1))	;if not hit and full update to evicting entry
					U_CacheL1_Dirty))
				)
				(U_CacheL1_PhyAddr 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_PhyAddr Cache_avi_entry LFB_PhyAddr) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_PhyAddr cache_evict_entry LFB_PhyAddr)	;if not hit and full update to evicting entry
					U_CacheL1_PhyAddr))
				)
				(U_CacheL1_VirAddr 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_VirAddr Cache_avi_entry LFB_VirAddr) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_VirAddr cache_evict_entry LFB_VirAddr)	;if not hit and full update to evicting entry
					U_CacheL1_VirAddr))
				)
				(U_CacheL1_Value 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_Value Cache_avi_entry LFB_Value) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_Value cache_evict_entry LFB_Value)	;if not hit and full update to evicting entry
					U_CacheL1_Value))
				)
				(U_CacheL1_PID 
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_CacheL1_PID Cache_avi_entry LFB_PID) ;if not hit and not full update to available entry
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full))	(store U_CacheL1_PID cache_evict_entry LFB_PID)	;if not hit and full update to evicting entry
					U_CacheL1_PID))
				)
				
				(U_LFB_Busy	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_Busy LFB_Retire_index (_ bv0 1))	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_Busy LFB_Retire_index (_ bv1 1))	;if not hit and full swap wirh evicting entry				
					U_LFB_Busy))
				)
				(U_LFB_OP	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_OP LFB_Retire_index 0)	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_OP LFB_Retire_index TL2)	;if not hit and full swap wirh evicting entry				
					U_LFB_OP))
				)
				(U_LFB_PhyAddr	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_PhyAddr LFB_Retire_index 0)	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_PhyAddr LFB_Retire_index (select U_CacheL1_PhyAddr cache_evict_entry))	;if not hit and full swap wirh evicting entry				
					U_LFB_PhyAddr))
				)
				(U_LFB_VirAddr	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_VirAddr LFB_Retire_index 0)	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_VirAddr LFB_Retire_index (select U_CacheL1_VirAddr cache_evict_entry))	;if not hit and full swap wirh evicting entry				
					U_LFB_VirAddr))
				)
				(U_LFB_Value	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_Value LFB_Retire_index 0)	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_Value LFB_Retire_index (select U_CacheL1_Value cache_evict_entry))	;if not hit and full swap wirh evicting entry				
					U_LFB_Value))
				)
				(U_LFB_PID	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_PID LFB_Retire_index (_ bv0 1))	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_PID LFB_Retire_index (select U_CacheL1_PID cache_evict_entry))	;if not hit and full swap wirh evicting entry				
					U_LFB_PID))
				)
				(U_LFB_WakeupID	
					(ite (and (= #b0 Cache_hit) (= #b0 Cache_full)) (store U_LFB_WakeupID LFB_Retire_index (_ bv0 2))	;if not hit and not full remove entry, its done
					(ite (and (= #b0 Cache_hit) (= #b1 Cache_full)) (store U_LFB_WakeupID LFB_Retire_index (_ bv0 2))	;if not hit and full swap wirh evicting entry				
					U_LFB_WakeupID))
				)
			)
;-----------------------------Property--------------------------------------------------------------		
		(=> 
			(and 
				(or (= T_IP_OP Load) (= T_IP_OP Store))
				(= T_IP_InstPID T_IP_ValuePID)
				(= #b1 U_IP_Done)
			)
			(= U_IP_InstPID U_IP_ValuePID)
		
		))))))))))))))))))
	)
)


(check-sat)
;(

;)